/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.vse.keg.corpusbuilder.csv;

import au.com.bytecode.opencsv.CSVReader;
import gate.Annotation;
import gate.AnnotationSet;
import gate.Corpus;
import gate.Document;
import gate.Factory;
import gate.FeatureMap;
import gate.creole.ResourceInstantiationException;
import gate.util.InvalidOffsetException;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.DataOutputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.util.Iterator;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 *
 * @author Milan
 */
public class CSVImporter {
    
    private static CSVImporter importer = null;
    
    public static CSVImporter getInstance(){
        if(importer == null){
            importer = new CSVImporter();
        }
        return importer;
    }
    
    public void importCSV(String datasetLoc, int typeColumnId, int entityColumnId, int entityURIColumnId, int textIdColumnId, int textColumnId, int mostFrequentSense, int incorrectCapitalization, int entityTag, String outputAnnotationSetName, String outputCorpusName, String generatedAnnotationsName) {
        try {
            CSVReader reader = new CSVReader(new FileReader(datasetLoc));
            String [] nextLine;
            
            Corpus wikicorpus = Factory.newCorpus(outputCorpusName);
            int textId = 0;
            Document doc = null;
            AnnotationSet gsAnnots = null;
            nextLine = reader.readNext();
            
            while ((nextLine = reader.readNext()) != null) {
                
                String text = nextLine[textColumnId];
                String entity = nextLine[entityColumnId];
                String entityURI = nextLine[entityURIColumnId];
                String type = nextLine[typeColumnId];
                String mfs = nextLine[mostFrequentSense];
                String iCapitalization = nextLine[incorrectCapitalization];
                String eTag = nextLine[entityTag];
                
                if(textId == Integer.parseInt(nextLine[textIdColumnId])) {
                    
                    textId = Integer.parseInt(nextLine[textIdColumnId]);
                    gsAnnots = doc.getAnnotations(outputAnnotationSetName);
                    int lastIndex = 0;
                    
                    while(lastIndex != -1) {
                        
                           lastIndex = text.indexOf(entity,lastIndex);
                           if( lastIndex != -1) {
                               
                               FeatureMap fm = gate.Factory.newFeatureMap();
                               fm.put("entity", entity);
                               fm.put("entityURI", "http://dbpedia.org/resource/"+entityURI);
                               fm.put("typeURI", "http://dbpedia.org/ontology/"+type);
                               fm.put("mfs", mfs);
                               fm.put("capitalization", iCapitalization);
                               fm.put("eTag", eTag);
                               int end = lastIndex+entity.length();
                               long startOffset = Long.parseLong(lastIndex+"");
                               long endOffset = Long.parseLong(end+"");
                               gsAnnots.add(startOffset, endOffset, generatedAnnotationsName, fm);
                               lastIndex+=entity.length();
                          }
                    }
                } else {
                    if(doc != null){
                        wikicorpus.add(doc);
                    }
                    textId = Integer.parseInt(nextLine[textIdColumnId]);
                    doc = Factory.newDocument(text);
                    gsAnnots = doc.getAnnotations(outputAnnotationSetName);
                    int lastIndex = 0;
                    
                    while(lastIndex != -1) {
                           lastIndex = text.indexOf(entity,lastIndex);
                           if( lastIndex != -1){
                               
                               FeatureMap fm = gate.Factory.newFeatureMap();
                               fm.put("entity", entity);
                               fm.put("entityURI", "http://dbpedia.org/resource/"+entityURI);
                               fm.put("typeURI", "http://dbpedia.org/ontology/"+type);
                               fm.put("mfs", mfs);
                               fm.put("capitalization", iCapitalization);
                               fm.put("eTag", eTag);
                               int end = lastIndex+entity.length();
                               long startOffset = Long.parseLong(lastIndex+"");
                               long endOffset = Long.parseLong(end+"");
                               gsAnnots.add(startOffset, endOffset, generatedAnnotationsName, fm);
                               lastIndex+=entity.length();
                          }
                    }
                }
            }
            if(doc != null){
                wikicorpus.add(doc);
            }
        } catch (FileNotFoundException ex) {
            Logger.getLogger(CSVImporter.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(CSVImporter.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ResourceInstantiationException ex) {
            Logger.getLogger(CSVImporter.class.getName()).log(Level.SEVERE, null, ex);
        } catch (InvalidOffsetException ex) {
            Logger.getLogger(CSVImporter.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}