/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.vse.keg.corpusbuilder.csv;

import gate.Corpus;
import gate.Document;
import gate.Factory;
import gate.ProcessingResource;
import gate.Resource;
import gate.creole.AbstractLanguageAnalyser;
import gate.creole.ExecutionException;
import gate.creole.ResourceInstantiationException;
import java.io.BufferedReader;
import java.io.FileReader;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * @author Milan Dojchinovski
 * <milan (at) dojchinovski (dot) mk>
 * Twitter: @m1ci
 * www: http://dojchinovski.mk
 */
public class TweetsCorpusBuilderPR extends AbstractLanguageAnalyser implements ProcessingResource {

    private Corpus corpus = null;
    private String datasetLocation;
    private String textIdColumnId;
    private String entityNameColumnId;
    private String entityURIColumnId;
    private String type;
    private String textColumnId;
    private String mostFrequentSense;
    private String incorrectCapitalization;
    private String entityTag;
    private String outputAnnotationSetName;
    private String outputCorpusName;
    private String generatedAnnotationsName;
    
    public TweetsCorpusBuilderPR() {
    }

    @Override
    public Resource init() throws ResourceInstantiationException {
        System.out.println("CSVCorpusBuilderPR was successfully inicialized.");
        return super.init();
    }
    
    @Override
    public void reInit() throws ResourceInstantiationException {
        init();
    }
        
    @Override
    public void execute() throws ExecutionException {
        CSVImporter.getInstance().importCSV(
                getDatasetLocation(),
                Integer.parseInt(type),
                Integer.parseInt(entityNameColumnId),
                Integer.parseInt(entityURIColumnId),
                Integer.parseInt(textIdColumnId),
                Integer.parseInt(textColumnId),
                Integer.parseInt(mostFrequentSense),
                Integer.parseInt(incorrectCapitalization),
                Integer.parseInt(entityTag),
                outputAnnotationSetName,
                outputCorpusName,
                generatedAnnotationsName);
    }
    
    @Override
    public Corpus getCorpus() {
        return corpus;
    }

    @Override
    public void setCorpus(Corpus corpus) {
        this.corpus = corpus;
    }

    /**
     * @return the datasetLocation
     */
    public String getDatasetLocation() {
        return datasetLocation;
    }

    /**
     * @param JAPEPATH_EN the JAPEPATH_EN to set
     */
    public void setDatasetLocation(String datasetLocation) {
        this.datasetLocation = datasetLocation;
    }
    
    /**
     * @return the JAPEPATH_NL
     */
    public String getTextIdColumnId() {
        return textIdColumnId;
    }

    /**
     * @param JAPEPATH_NL the JAPEPATH_NL to set
     */
    public void setTextIdColumnId(String textIdColumnId) {
        this.textIdColumnId = textIdColumnId;
    }

    /**
     * @return the entityNameColumnId
     */
    public String getEntityNameColumnId() {
        return entityNameColumnId;
    }

    /**
     * @param entityNameColumnId the entityNameColumnId to set
     */
    public void setEntityNameColumnId(String entityNameColumnId) {
        this.entityNameColumnId = entityNameColumnId;
    }

    /**
     * @return the entityURIColumnId
     */
    public String getEntityURIColumnId() {
        return entityURIColumnId;
    }

    /**
     * @param entityURIColumnId the entityURIColumnId to set
     */
    public void setEntityURIColumnId(String entityURIColumnId) {
        this.entityURIColumnId = entityURIColumnId;
    }

    /**
     * @return the type
     */
    public String getType() {
        return type;
    }

    /**
     * @param type the type to set
     */
    public void setType(String type) {
        this.type = type;
    }

    /**
     * @return the textColumnId
     */
    public String getTextColumnId() {
        return textColumnId;
    }

    /**
     * @param textColumnId the textColumnId to set
     */
    public void setTextColumnId(String textColumnId) {
        this.textColumnId = textColumnId;
    }

    /**
     * @return the mostFrequentSense
     */
    public String getMostFrequentSense() {
        return mostFrequentSense;
    }

    /**
     * @param mostFrequentSense the mostFrequentSense to set
     */
    public void setMostFrequentSense(String mostFrequentSense) {
        this.mostFrequentSense = mostFrequentSense;
    }

    /**
     * @return the incorrectCapitalization
     */
    public String getIncorrectCapitalization() {
        return incorrectCapitalization;
    }

    /**
     * @param incorrectCapitalization the incorrectCapitalization to set
     */
    public void setIncorrectCapitalization(String incorrectCapitalization) {
        this.incorrectCapitalization = incorrectCapitalization;
    }

    /**
     * @return the entityTag
     */
    public String getEntityTag() {
        return entityTag;
    }

    /**
     * @param entityTag the entityTag to set
     */
    public void setEntityTag(String entityTag) {
        this.entityTag = entityTag;
    }

    /**
     * @return the outputAnnotationSetName
     */
    public String getOutputAnnotationSetName() {
        return outputAnnotationSetName;
    }

    /**
     * @param outputAnnotationSetName the outputAnnotationSetName to set
     */
    public void setOutputAnnotationSetName(String outputAnnotationSetName) {
        this.outputAnnotationSetName = outputAnnotationSetName;
    }

    /**
     * @return the outputCorpusName
     */
    public String getOutputCorpusName() {
        return outputCorpusName;
    }

    /**
     * @param outputCorpusName the outputCorpusName to set
     */
    public void setOutputCorpusName(String outputCorpusName) {
        this.outputCorpusName = outputCorpusName;
    }

    /**
     * @return the generatedAnnotationsName
     */
    public String getGeneratedAnnotationsName() {
        return generatedAnnotationsName;
    }

    /**
     * @param generatedAnnotationsName the generatedAnnotationsName to set
     */
    public void setGeneratedAnnotationsName(String generatedAnnotationsName) {
        this.generatedAnnotationsName = generatedAnnotationsName;
    }


}
